#include<stdio.h>
#include<conio.h>

// set to nodes + 1 while debug
#define MAX 20
// don't set to 32767, will overflow and get neg values.
#define INF 32000

int main()
{
int arr[MAX][MAX],n;
int from[MAX],minwt[MAX],visited[MAX];
int i,j,min,cnt=0;

clrscr();

printf("Enter the number of vertices :\n");
scanf("%d",&n);

printf("Enter the weighted adjacency matrix (0 for not connected) :\n");

for(i=1;i<=n;i++)
 for(j=1;j<=n;j++)
 {  scanf("%d",&arr[i][j]);
    if(arr[i][j]==0) arr[i][j]=INF;
 }

//initialization
minwt[0]=INF;

for(i=1;i<=n;i++)
{ from[i]=-1;     //no use of init. if connected.
  minwt[i]=INF;
  visited[i]=0;
}

printf("Starting vertex 1.\n");
visited[1]=1;
minwt[1]=0;

i=1;


//start main algo
while(1)
{


  // fill "minwt" and "from" arrays
  for(j=1;j<=n;j++)
  {    if(i==j) continue;
 

      //dijkstras
      if((arr[i][j]+minwt[i]<minwt[j])&&(!visited[j]))
      { minwt[j]=arr[i][j]+minwt[i];
  	from[j]=i;
      }

  }

  
  //find min in minwt
  min=0;

  for(j=1;j<=n;j++)
  {
    if(minwt[j]<minwt[min]&&!visited[j]) min=j;
  }
  printf("%d nearest to %d : min wt from vertex 1 : %d\n",min,from[min],minwt[min]);
  cnt++;
  if(cnt==n-1) break;

  visited[min]=1;
  i=min; 

}



return 0;
}


