// delay and array len optimally set so that proper values are got.

#include<stdio.h>
#include<conio.h>
#include<process.h>
#include<dos.h>
#include<time.h>
#include<stdlib.h>

#define ARRAY_LEN 1000
#define DELAY_TIME 50
#define MAX_ARRAY_NO 32767

int linsearch(int *a,int start, int end, int no)
{ delay(DELAY_TIME);

	if (start > end) return -1;
	if(a[start] == no) return start;
	else return linsearch(a,++start,end,no);
}

int binsearch(int *a,int start, int end, int no)
{ delay(DELAY_TIME);

	if (start > end) return -1;
	int mid = (start + end) /2;

	if(a[mid] == no) return mid;
	else if ( no < a[mid])  return binsearch(a,start,mid-1,no);
	else return binsearch(a,mid+1,end,no);
}



int main()
{
 int arr[ARRAY_LEN],i,j,searchidx,no,resultidx,temp;
 long start,end;

 time_t t;
 srand((unsigned) time(&t));

 clrscr();

 for(i=0;i<ARRAY_LEN;i++)
 { arr[i] = rand() % MAX_ARRAY_NO;
 }


 for(i=0;i<ARRAY_LEN;i++)
 for(j=0;j<ARRAY_LEN-i-1;j++)
 { if(arr[j] > arr[j+1])
	{ temp = arr[j];
	  arr[j] = arr[j+1];
	  arr[j+1] = temp;
	}
 }



 searchidx = rand() % ARRAY_LEN;
 no = arr[searchidx];

 printf("Random Sample :\nSearch Index : %d\nNumber to search :%d\n",searchidx,no);

 start = clock();
 resultidx = linsearch(arr,0,ARRAY_LEN-1,no);
 end = clock();

 printf("\nLinear Search Results:\n");
 printf("Found at %d\n",resultidx);
 printf("Time taken (clock ticks) :%ld\n",end-start);


 start = clock();
 resultidx = binsearch(arr,0,ARRAY_LEN,no);
 end = clock();

 printf("\nBinary Search Results:\n");
 printf("Found at %d\n",resultidx);
 printf("Time taken (clock ticks) :%ld\n",end-start);

 printf("Press any key to end.\n");
 getch();

 return 0;
}

