/*
i have not checked whether the given digrpah is a dag or not, but i might be done by running a Warshall's at every stage and then checking i any of the diagonal elements is one (if efficiency is not a concern).
it is not explicitly asked in the question, so maybe, we can assume the input graphs will be dags.
*/
#include<stdio.h>
#include<conio.h>
#define MAX 20

int stack[MAX],top=-1;

void push(int item)
{ stack[++top]=item;
}

int pop()
{ return stack[top--];
}

int empty()
{ return top==-1;
}


int arr[MAX][MAX],n,visited[MAX]={0};


void dfs(int k)
{
 if(!visited[k])
 {
  visited[k]=1;
 for(int i=1;i<=n;i++)
  { if(arr[k][i] && !visited[i])
    { dfs(i);
    }
  }
 push(k);
 }
}


int main()
{     int i,j;


clrscr();

printf("Enter the number of vertices :\n");
scanf("%d",&n);

printf("Enter the 0/1 adjacency matrix :\n");

for(i=1;i<=n;i++)
 for(j=1;j<=n;j++)
 {  scanf("%d",&arr[i][j]);
 }


for(i=1;i<=n;i++)
{ dfs(i);
}


printf("Printing topologically sorted list :\n");
while(!empty()) { printf("%d ",pop()); }
return 0;
}
